//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.09.11
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#ifndef log_h
#define log_h
//-----
#include <iostream.h>
#include <string>
#include "def.h"
//using namespace std;

class Logcode{
	FILE *fp_log;
	string ghostpath;
	string logfilename;
	unsigned int log_on;
	unsigned int log_mode;
	unsigned int log_lv;
public:
	int init(string basepath,string filename);
	int close(void);
	int logwrite(string buffer,unsigned int lv);
//	int logwrite_s20_data(string title,s20_data inputevent,unsigned int lv);	// s20_data^̃f[^Oɏo͂

	int set_logon(unsigned int on);
	int set_logmode(unsigned int mode);
	int set_loglv(unsigned int lv);
};

#define LOG_STATIC		0
#define LOG_DYNAMIC		1


//---------------------------------------------------------------------------
//	s20_data^̃f[^Oɏo͂
//---------------------------------------------------------------------------
/*int logcode::logwrite_s20_data(string title,s20_data inputevent,unsigned int lv)
{
	string logtmp;
	
	if((log_on == ON) && (log_lv >= lv)){
		logtmp = string("-- ");
		logtmp.append(title);
		logtmp.append(" --\n");
		
		logtmp.append("Event: ");
		logtmp.append(inputevent.get_event());
		logtmp.append("\n");
		
		for(unsigned int count =0;count < inputevent.get_reference_size();count++){
			char tmp[4];
			itoa(count,tmp,10);
			logtmp.append("Reference");
			logtmp.append(tmp);
			logtmp.append(": ");
			logtmp.append(inputevent.get_reference(count));
			logtmp.append("\n");
			
		}
		
		logwrite(logtmp,lv);
		
	}
	
	return(OK);
}
*/

int Logcode::logwrite(string buffer,unsigned int lv)
{
	
	if((log_on == ON) && (log_lv >= lv)){
		if(log_mode == LOG_DYNAMIC){
//			cout << "Dynamic Wright\n";
			if((fp_log = fopen(logfilename.c_str(),"at"))==NULL){
				/* nasino.ini don't open!! */
//				printf("testlogfile don't open!!\n");
				return(0);
			}else{
				fputs(buffer.c_str(),fp_log);
				fclose(fp_log);
			}
		}else{
//			cout << "Static Wright\n";
			fputs(buffer.c_str(),fp_log);
		}
	}

	return(OK);
}

int Logcode::close(void)
{
	if(log_mode != LOG_DYNAMIC){
//		cout << "Static Close\n";
		fclose(fp_log);
	}else{
//		cout << "Dynamic Close\n";
	}
	return(OK);
}

int Logcode::init(string basepath,string filename)
{
//	cout << "Log Init.\n";

	ghostpath = basepath;
	logfilename = ghostpath;
	logfilename.append(filename);

	if(log_mode != LOG_DYNAMIC){
		if((fp_log = fopen(logfilename.c_str(),"at"))==NULL){
//			cout << "Logfile open error!!\n";
		}else{
			logwrite("--- Log Write Start. ---\n",0);
			logwrite("Log mode : STATIC.\n",0);
//			cout << "Log mode STATIC.\n";
		}
	}else{
		logwrite("--- Log Write Start. ---\n",0);
		logwrite("Log mode : DYNAMIC.\n",0);
//		cout << "Log mode DYNAMIC.\n";
	}
	
	char lv[4];
	logwrite("Log Lv : ",0);
	itoa(log_lv,lv,10);
	logwrite(lv,0);
	logwrite("\n",0);

	return(OK);
}

int Logcode::set_logon(unsigned int on)
{
	log_on = on;
	return(OK);
}

int Logcode::set_logmode(unsigned int mode)
{
	log_mode = mode;
	return(OK);
}

int Logcode::set_loglv(unsigned int lv)
{
	log_lv = lv;
	return(OK);
}



#endif
