//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.02.23
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------

#include <iostream.h>
#include <string>               // for string class
#include "def.h"
#include "nasino_dic.h"


#pragma inline dic_word_rspacecut		// tasmKv
#pragma inline dic_chkstop				// tasmKv
#pragma inline dic_getword_escape1		// tasmKv
#pragma inline dic_getword_escape2		// tasmKv
#pragma inline dic_getword_escape3		// tasmKv
//#pragma inline dic_chksymsj				// tasmKv
#pragma inline dic_checksjcode			// tasmKv


//--------------------
//	[J֐錾
//--------------------
void dic_word_rspacecut(string *word);
unsigned int dic_chkstop(unsigned char sym,unsigned int mode);
int dic_getword_escape1(string *word,string *buffer);
int dic_getword_escape2(string *word,string *buffer);
int dic_getword_escape3(string *word,string *buffer);
#define dic_getsym dic_getsymsj
int dic_getsymsj(string *sym,string *buffer);
#define dic_chksym dic_chksymsj
int dic_chksymsj(string *sym,string *buffer);
int dic_checksjcode(unsigned char sym);

void dic_read_space(string *buffer);

//--------------------



//---------------------------------------------------------------------------
//	<NAME>		dic_fgetline
//
//	<FUNCTION>	t@Cso
//
//	string *buffer				OUT		o͕
//	FILE *fp_dic				IN/OUT	t@C|C^
//	return						OUT		t@C|C^
//
//---------------------------------------------------------------------------
char *dic_fgetline(string *buffer,FILE *fp_dic)
{
	char *loop;
	int loop2;
	char data_buffer[BUFFER_LEN];

	*buffer = string("");
	data_buffer[0] = '\0';
	loop2 = ON;
	do{
		loop = fgets(data_buffer,BUFFER_LEN,fp_dic);
		if(data_buffer[strlen(data_buffer)-1] == '\n'){
			loop2 = OFF;
		}
		buffer->append(data_buffer);
	}while((loop2 == ON) && (loop != NULL));

	return(loop);
}

//---------------------------------------------------------------------------
//	<NAME>		dic_getword
//
//	<FUNCTION>	񂩂o
//
//	string *buffer				IN		͕
//	string *word				OUT		oword
//	return						OUT
//
//	񂩂؂oB
//	*buffer͐؂ꂽAOɋl߂B
//	̑Oɂu vu\tvu,v͖B
//	u\tvu,vu\0vu\nvu0x0dv؂蕶ƂB
//	؂蕶*bufferɎcȂB
//	u""v̊Ԃ́̕u\vGXP[vƂȊO͖Ɏ肱܂B
//	u\v̓GXP[vƂA1͖Ɏ肱܂B
//	悤ɂSAKURAXNvg\ĤłȂB
//	ShiftJIS΍
//	
//---------------------------------------------------------------------------
/*
int dic_getword(string *word,string *buffer,unsigned int mode)
{
	int ret;
	unsigned int loop;
	unsigned int symbol_len;
	string sym;
	static char sym2;

	// buffer̓̋󔒂ǂݔ΂
	dic_read_space(buffer);

	*word = string("");
	loop = ON;
	do{
		symbol_len = dic_chksym(&sym,buffer);

		if(symbol_len == 1){							// 1bytȅ
			sym2 = sym.at(0);
			if(sym2 == '\"'){								// "B""Ԃ͖̕Ŏ肱ށB
//				sym = string("");
				dic_getsym(&sym,buffer);
				loop = dic_getword_escape1(word,buffer);
//			}else if(sym2 == '\\'){						// \B\̌̈ꕶ͖Ŏ肱ށB
//				dic_getword_escape2(word,buffer);
			}else if((mode == DIC_GET_ENTRY ) && (sym2 == '[')){	// [B[]Ԃ͖̕Ŏ肱ށB
				word->append(sym);
				loop = dic_getword_escape3(word,buffer);
			}else{
				
				switch(mode){
					case DIC_GET_ENTRY:
						if( (sym2 == ',') || (sym2 == '&') || (sym2 == '\0') || (sym2 == '\n') || (sym2 == 0x0d) || (sym2==':') ){
							loop = OFF;
						}
						break;
					case DIC_GET_LINE:
					case DIC_GET_SHIORI_LINE:
						if( (sym2 == '\0') || (sym2 == '\n') || (sym2 == 0x0d) ){
							loop = OFF;
						}
						break;
					case DIC_GET_SHIORI_HEADER:
					case DIC_GET_NIS_WORD:
						if( (sym2 == ' ') || (sym2 == '\0') || (sym2 == '\n') || (sym2 == 0x0d) ){
							loop = OFF;
						}
						break;
					case DIC_GET_REFERENCE_CHK:
						if( (sym2 == ']') || (sym2 == '\0') || (sym2 == '\n') || (sym2 == 0x0d) ){
							loop = OFF;
						}
						break;
					case DIC_GET_REFERENCE_LOGIC_WORD:
						if( (sym2 == ',') || (sym2 == '\0') || (sym2 == '\n') || (sym2 == 0x0d)
						 || (sym2 == '(') || (sym2 == ')') || (sym2 == '&') || (sym2 == '|') || (sym2 == '!') ){
							loop = OFF;
						}
						break;
					case DIC_GET_REFERENCE_LOGIC_SYM:
						if(!( (sym2 == ',') || (sym2 == '\0') || (sym2 == '\n') || (sym2 == 0x0d)
						 || (sym2 == '(') || (sym2 == ')') || (sym2 == '&') || (sym2 == '|') || (sym2 == '!') )){
							loop = OFF;
						}
						break;
					case DIC_GET_DICWORD:
					default:
						if( (sym2 == ',') || (sym2 == '\0') || (sym2 == '\n') || (sym2 == 0x0d) ){
							loop = OFF;
						}
						break;
				}

//				loop = dic_chkstop(sym2,mode);
				if(loop != OFF){
//					sym = string("");
//					dic_getsym(&sym,buffer);
					buffer->erase(0,1);
					word->append(sym);
				}
			}
		}else if(symbol_len == 2){						// 2bytȅ
//			sym = string("");
//			dic_getsym(&sym,buffer);
			buffer->erase(0,2);
			word->append(sym);
		}
//		cout << *word << "\n";
	}while((buffer->size()>0) && (loop == ON));

	dic_word_rspacecut(word);		// s'\n'' ''\t'͎菜 

//	if((word->size() > 0) && (loop == OFF)){
	if(word->size() > 0){
//		cout << "OK!\n";
		ret = OK;
	}else{
//		cout << "NG!\n";
		ret = NG;
	}

	return(ret);
}
*/

int dic_getword(string *word,string *buffer,unsigned int mode)
{
	int ret;
	unsigned int loop;
	unsigned int symbol_len;
	string sym;

	// buffer̓̋󔒂ǂݔ΂
	dic_read_space(buffer);

	*word = string("");
	loop = ON;
	do{
		symbol_len = dic_chksym(&sym,buffer);

		if(symbol_len == 1){							// 1bytȅ
			if(sym.at(0) == '\"'){								// "B""Ԃ͖̕Ŏ肱ށB
//				sym = string("");
				dic_getsym(&sym,buffer);
				loop = dic_getword_escape1(word,buffer);
//			}else if(sym.at(0) == '\\'){						// \B\̌̈ꕶ͖Ŏ肱ށB
//				dic_getword_escape2(word,buffer);
			}else if((mode == DIC_GET_ENTRY ) && (sym.at(0) == '[')){	// [B[]Ԃ͖̕Ŏ肱ށB
				word->append(sym);
				loop = dic_getword_escape3(word,buffer);
			}else{
				loop = dic_chkstop(sym.at(0),mode);
				if(loop != OFF){
//					sym = string("");
					dic_getsym(&sym,buffer);
					word->append(sym);
				}
			}
		}else if(symbol_len == 2){						// 2bytȅ
//			sym = string("");
			dic_getsym(&sym,buffer);
			word->append(sym);
		}
//		cout << *word << "\n";
	}while((buffer->size()>0) && (loop == ON));

	dic_word_rspacecut(word);		// s'\n'' ''\t'͎菜 

//	if((word->size() > 0) && (loop == OFF)){
	if(word->size() > 0){
//		cout << "OK!\n";
		ret = OK;
	}else{
//		cout << "NG!\n";
		ret = NG;
	}

	return(ret);
}


//---------------------------------------------------------------------------
//	<NAME>		dic_getsym
//
//	<FUNCTION>	V{1؂o B
//				buffer͐؂oꂽOɋl߂B
//				dic_getsymsj()ĂԂBR[hǂƂ́AłȂƂB
//
//	string *sym		OUT		o
//	string *buffer	IN		͕
//	return			OUT		obyte
//---------------------------------------------------------------------------
//int dic_getsym(string *sym,string *buffer)
//{
//	return(dic_getsymsj(sym,buffer));
//}

//---------------------------------------------------------------------------
//	<NAME>		dic_chksym
//
//	<FUNCTION>	V{1؂o B
//				dic_chksymsj()ĂԂBR[hǂƂ́AłȂƂB
//
//	string *sym		OUT		o
//	string *buffer	IN		͕
//	return			OUT		obyte
//---------------------------------------------------------------------------
//int dic_chksym(string *sym,string *buffer)
//{
//	return(dic_chksymsj(sym,buffer));
//}

//---------------------------------------------------------------------------
//	<NAME>		read_space
//
//	<FUNCTION>	󔒕ǂݔ΂
//				󔒁i' ','\t'jǂݔ΂B
//
//	string *buffer	IN		͕
//	return			OUT		
//---------------------------------------------------------------------------
void dic_read_space(string *buffer)
{
	if(buffer->size()>0){
		while((buffer->size()>0) && (buffer->at(0)==' ' || buffer->at(0)=='\t')){	// 󔒂ǂݔ΂B','͔΂ȂB
			buffer->erase(0,1);
		}
	}

	return;
}

//---------------------------------------------------------------------------
//	<NAME>		dic_getline
//
//	<FUNCTION>	s؂
//				󔒁i' ','\t'jǂݔ΂B
//
//	string *buffer	IN		͕
//	tring *lineword	OUT		؂s
//	return			OUT		OK	linewordL
//---------------------------------------------------------------------------
int dic_getline(string *lineword,string *buffer)
{
	int ret;
	string sym;
	
	ret = dic_getword(lineword,buffer,DIC_GET_LINE);

	if(buffer->size() > 0){
		do{
			if(buffer->at(0)==0x0d || buffer->at(0)==0x0a){	// 擪0x0d,0x0a폜
				dic_getsym(&sym,buffer);
			}
		}while((buffer->size()>0) && (sym.at(0) != 0x0a) && (sym.at(0) != 0x0d));
//		}while((buffer->size()>0) && (sym.at(0) != 0x0a));
	}
	
	return(ret);
}



//---------------------------------------------------------------------------
//	<NAME>		dic_chkstop
//
//	<FUNCTION>	dic_getword()̏I
//
//		unsigned char sym			IN		͕
//		unsigned int mode			IN		؂̑I
//				DIC_GET_ENTRY1		, \0 \n 0x0d :
//				DIC_GET_DICWORD		, \0 \n 0x0d
//				DIC_GET_SHIORI_HEADER	' ' \0 \n 0x0d
//		return(int)					OUT		ON : IȂ
//											OFF: I
//---------------------------------------------------------------------------
unsigned int dic_chkstop(unsigned char sym,unsigned int mode)
{
	int ret;
	
	ret = ON;
	switch(mode){
		case DIC_GET_ENTRY:
			if( (sym == ',') || (sym == '&') || (sym == '\0') || (sym == '\n') || (sym == 0x0d) || (sym==':') ){
				ret = OFF;
			}
			break;
		case DIC_GET_LINE:
		case DIC_GET_SHIORI_LINE:
		case DIC_GET_SAORI_LINE:
			if( (sym == '\0') || (sym == '\n') || (sym == 0x0d) ){
				ret = OFF;
			}
			break;
		case DIC_GET_SHIORI_HEADER:
		case DIC_GET_NIS_WORD:
		case DIC_GET_SAORI_DATA:
			if( (sym == ' ') || (sym == '\0') || (sym == '\n') || (sym == 0x0d) ){
				ret = OFF;
			}
			break;
		case DIC_GET_REFERENCE_CHK:
			if( (sym == ']') || (sym == '\0') || (sym == '\n') || (sym == 0x0d) ){
				ret = OFF;
			}
			break;
		case DIC_GET_REFERENCE_LOGIC_WORD:
			if( (sym == ',') || (sym == '\0') || (sym == '\n') || (sym == 0x0d)
			 || (sym == '(') || (sym == ')') || (sym == '&') || (sym == '|') || (sym == '!') ){
				ret = OFF;
			}
			break;
		case DIC_GET_REFERENCE_LOGIC_SYM:
			if(!( (sym == ',') || (sym == '\0') || (sym == '\n') || (sym == 0x0d)
			 || (sym == '(') || (sym == ')') || (sym == '&') || (sym == '|') || (sym == '!') )){
				ret = OFF;
			}
			break;
		case DIC_GET_EQ_LEFT:
			if( (sym == '=') || (sym == '\0') || (sym == '\n') || (sym == 0x0d) ){
				ret = OFF;
			}
			break;
		case DIC_GET_DICWORD:
		default:
			if( (sym == ',') || (sym == '\0') || (sym == '\n') || (sym == 0x0d) ){
				ret = OFF;
			}
			break;
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		dic_getword_escape1
//
//	<FUNCTION>	GXP[vV[PX̂P
//
//		string *word				IN/OUT		o͕
//		string *buffer				IN/OUT		͕
//		return(int)					OUT			ON : I
//												OFF: ُI
//	u""v̕o
//
//---------------------------------------------------------------------------
int dic_getword_escape1(string *word,string *buffer)
{
	string sym;
	unsigned int symbol_len;
	unsigned int ret;
	
	ret = ON;
	do{
		symbol_len = dic_getsym(&sym,buffer);
		if(symbol_len == 1){								// 1bytȅ
			if(sym[0] == '\\'){									// \B\͖̌̕Ŏ肱ށB
				dic_getword_escape2(word,buffer);
			}else if(sym[0] != '\"'){							// "ȊO̕
				word->append(sym);
			}
		}else if(symbol_len == 2){							// 2bytȅ
			word->append(sym);
		}
	}while((buffer->size()>0) && (sym.at(0) != '\"') && (ret != OFF));
	
	return(ret);
}


//---------------------------------------------------------------------------
//	<NAME>		dic_getword_escape2
//
//	<FUNCTION>	GXP[vV[PX̂Q
//
//		string *word				IN/OUT		o͕
//		string *buffer				IN/OUT		͕
//		return(int)					OUT			ON : I
//												OFF: ُI
//	u\v̌̕肱ޏB
//	*buffer̐擪̈ꕶ*wordɉB
//
//---------------------------------------------------------------------------
int dic_getword_escape2(string *word,string *buffer)
{
	string sym;
	unsigned int symbol_len;
	unsigned int ret;
	
	ret = ON;
	symbol_len = dic_getsym(&sym,buffer);

	if(symbol_len == 1){								// 1bytȅ
		if(sym.at(0) == '\\'){									// \B\̌̕n,ȑꍇ͓ꏈB
			symbol_len = dic_chksym(&sym,buffer);
			if(symbol_len == 1){								// 1bytȅ
				if(sym[0] == 'n'){
					dic_getsym(&sym,buffer);
					sym = string("\n");
				}else if(sym[0] == 'r'){
					dic_getsym(&sym,buffer);
					sym = string("\r");
				}
			}
		}
	}

	word->append(sym);
	
	return(ret);
}


//---------------------------------------------------------------------------
//	<NAME>		dic_getword_escape3
//
//	<FUNCTION>	GXP[vV[PX̂R
//
//		string *word				IN/OUT		o͕
//		string *buffer				IN/OUT		͕
//		return(int)					OUT			ON : I
//												OFF: ُI
//	u[]v̕o
//
//---------------------------------------------------------------------------
int dic_getword_escape3(string *word,string *buffer)
{
	string sym;
	unsigned int symbol_len;
	unsigned int ret;
	
	ret = ON;
	do{
		symbol_len = dic_getsym(&sym,buffer);
		if(symbol_len == 1){								// 1bytȅ
			if(sym[0] == '\\'){									// \B\͖̌̕Ŏ肱ށB
				dic_getword_escape2(word,buffer);
			}else if(sym[0] != '['){							// "ȊO̕
				word->append(sym);
			}
		}else if(symbol_len == 2){							// 2bytȅ
			word->append(sym);
		}
	}while((buffer->size()>0) && (sym.at(0) != ']') && (ret != OFF));
	
	return(ret);
}


//---------------------------------------------------------------------------
//	<NAME>		dic_getsymsj
//
//	<FUNCTION>	V{1؂o S-JISR[hΉ
//				buffer͐؂oꂽOɋl߂B
//
//	string *sym		OUT		o
//	string *buffer	IN		͕
//	return			OUT		obyte
//---------------------------------------------------------------------------
int dic_getsymsj(string *sym,string *buffer)
{
	int ret;

	*sym = string("");
	if(buffer->size() > 0){
		if(dic_checksjcode(buffer->at(0)) == OK){
//			S-JIS
			sym->append(&(buffer->at(0)),2);
			buffer->erase(0,2);
			ret = 2;
		}else{
//			1byte
			sym->append(&(buffer->at(0)),1);
			buffer->erase(0,1);
			ret = 1;
		}
	}else{
//		cout << "ERROR dic_getsymsj\n";
		ret = 0;
	}

	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		dic_chksymsj
//
//	<FUNCTION>	V{1؂o S-JISR[hΉ
//				buffer̓e͕ωȂB
//
//	string *buffer	IN		͕
//	string *sym		OUT		o
//	return			OUT		obyte
//---------------------------------------------------------------------------
int dic_chksymsj(string *sym,string *buffer)
{
	int ret;

	*sym = string("");
	if(buffer->size() > 0){
		if(dic_checksjcode(buffer->at(0)) == OK){
//			S-JIS
			sym->append(&(buffer->at(0)),2);
			ret = 2;
		}else{
//			1byte
			sym->append(&(buffer->at(0)),1);
			ret = 1;
		}
	}else{
		ret = 0;
	}

	return(ret);
}

//---------------------------------------------------------------------------
//	S-JISPoCgڂ̃`FbN
//	[_[oCg		0x81-0x9F, 0xE0-0xEF, 0xF0-0xFC*
//	g[[oCg	0x40-0x7E, 0x80-0xFC		
//
//	unsigned char sym	IN		`FbNR[h(1byte)
//	int ret				OUT		OK : S-JIS1byte
//								NG : ł͂Ȃ
//---------------------------------------------------------------------------
int dic_checksjcode(unsigned char sym)
{
	int ret;

	if(((sym >= 0x81) && (sym <= 0x9f)) || ((sym >= 0xE0) && (sym <= 0xEF)) || ((sym >= 0xF0) && (sym <= 0xFC))){
		ret = OK;
	}else{
		ret = NG;
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		wordI[̋󔒂폜
//
//		*word		IN		͕
//---------------------------------------------------------------------------
void dic_word_rspacecut(string *word)
{
	int count;
	
	count = word->size();
	if(count > 0){
		while((word->at(count-1)=='\n') || (word->at(count-1)==' ') || (word->at(count-1)=='\t')){		/* s'\n'' ''\t'͎菜 */
			count--;
			word->erase(count,1);
		}
	}
	
	return;
}


// ####################################################
/*
//---------------------------------------------------------------------------
//		Í
//---------------------------------------------------------------------------
string DecryptString(string encodedstr)
{
	string decodedstr;
	string str;
	
	if(encodedstr.find("!KAWA0000")==0){
		encodedstr.erase(0,9);
//		cout << encodedstr << "\n";
		
		str = DecodeBase64(encodedstr);
		for(unsigned int i=0;i<str.size();i++) {
			decodedstr += (char)(str[i]^0xcc);
		}
		decodedstr += ('\n');
	}else{
//		cout << encodedstr << "\n";
		decodedstr = encodedstr;
//		cout << decodedstr << "\n";
	}

	return(decodedstr);
}
*/

// ####################################################
//---------------------------------------------------------------------------
//		LOGo
//---------------------------------------------------------------------------
/*
int logwrite(class dic_file dic,const char* logword)
{
	FILE *fp_log;
	char filename[256];
	
//	if(Log == ON){
		sprintf(filename,"%s%s",(dic.get_ghostpath()).c_str(),"nasino_log.txt");
		printf("ini filename : %s\n",filename);

		if((fp_log = fopen(filename,"at"))==NULL){
			// nasino.ini don't open!!
			printf("testlogfile don't open!!\n");
			return(0);
		}else{
			fputs(logword,fp_log);
			fclose(fp_log);
		}
//	}

	return(0);
}

*/
