//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.09.22
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#include <windows.h>

#include <iterator>
#include <iostream.h>
#include <string>               // for string class
#include "def.h"
#include "saori.h"
#include "nasino_dic.h"
#include "log.h"

#include "date_main.h"

Logcode log;					// Log

int saori_load(string datapath)
{
	int ret;
	
//	log.init(datapath,"date.log");
//	log.set_logon(ON);
//	log.set_loglv(1);
//	log.set_logmode(LOG_DYNAMIC);
//	log.logwrite("=== TimeCheck.dll Load ===\n",1);
	
	ret = TRUE;
	
	return(ret);
}

int saori_unload(void)
{
	int ret;
	
//	log.logwrite("=== TimeCheck.dll Unload ===\n",1);
//	log.close();
	
	ret = TRUE;
	
	return(ret);
}

int saori_execute(string *request_buffer)
{
	int ret;
	Saori_data saoridata;
	
	saoridata.decode(*request_buffer);
	
	saoridata.view();
	
	if(saoridata.ger_command_code() == COM_GET_VERSION){
		saoridata.set_returncode(200);
	}else if(saoridata.ger_command_code() == COM_EXECUTE){
//		cout << "COM_EXECUTE\n";
//		log.logwrite(saoridata.get_argument(0),1);
//		log.logwrite("\n",1);
		saoridata.set_returncode(date_main(&saoridata));
	}
	
	saoridata.encode(request_buffer);
	
//	cout << "outputdata:\n" << *request_buffer << "\n";
	
	return(ret);
}


// ##########################################################################


int Saori_data::set_returncode(unsigned int code)
{
	int ret;
	
	returncode = code;
	
	return(ret);
}

int Saori_data::set_result(string buffer)
{
	int ret;
	
	result = buffer;
	
	return(ret);
}

int Saori_data::ger_command_code(void)
{
	return(command_code);
}

int Saori_data::set_value(string buffer,unsigned int num)
{
	int ret;
	
	ret = OK;
	
	if(value.size() < (num+1)){
		value.resize(num+1);
	}
	value[num] = buffer;
	
	return(ret);
}

string Saori_data::get_argument(unsigned int num)
{
	string ret;
	
	if(argument.size() > num){
		ret = argument[num];
	}else{
		ret = string("");
	}
	
	return(ret);
}

string Saori_data::get_value(unsigned int num)
{
	string ret;
	
	if(value.size() > num){
		ret = value[num];
	}else{
		ret = string("");
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		view
//
//	<FUNCTION>	
//---------------------------------------------------------------------------
int Saori_data::view(void)
{
	cout << "command_code\t:" << command_code << "\n";
	cout << "command_version\t:" << command_version << "\n";
	cout << "SecurityLevel\t:" << securitylevel << "\n";
	cout << "Charset\t\t:" << charset << "\n";
	
	for (unsigned int count = 0; count < argument.size(); ++count) {
		cout << "Argument" << count << "\t:" << argument[count] << "\n";
	}
	
	return(OK);
}


//---------------------------------------------------------------------------
//	<NAME>		decode
//
//	<FUNCTION>	requestf[^̃fR[hs
//---------------------------------------------------------------------------
int Saori_data::decode(string buffer)
{
	int ret;
	string linebuffer;
	string sym;
	
	ret = header_decode(&buffer);
//	cout << "buffer :\n" << buffer << "\n";
	
	if(ret != NG){
		do{
			dic_getline(&linebuffer,&buffer);
//			cout  << "\n" << linebuffer << "\n";
			if(linebuffer.size() > 0){
				ret = line_decode(linebuffer);
			}
		}while(buffer.size() > 0);
	}
	
	return(ret);
}





//---------------------------------------------------------------------------
//		SHIORI/2.0̃wb_fR[h
//		return		OUT		OK:fR[h		NG:fR[hs
//---------------------------------------------------------------------------
int Saori_data::line_decode(string buffer)
{
	string entry;
	string word;
	string sym;
//	int com_number;
	int ret;
	
//	cout << "line_decode: " << buffer << "\n";
	
	dic_getword(&entry,&buffer,DIC_GET_ENTRY);
//	cout << "entry: " << entry << "\n";
	dic_getsym(&sym,&buffer);
	if(strcmp(sym.c_str(),":") == 0){
		dic_getword(&word,&buffer,DIC_GET_LINE);
//		cout << word << "\n";
		if(entry.compare(SAORI_SECURITYLV)==0){
//			cout << "SAORI_SECURITYLV\n";
			securitylevel = word;
			ret = OK;
		}else if(entry.compare(SAORI_CHARSET)==0){
//			cout << "SAORI_CHARSET\n";
			charset = word;
			ret = OK;
		}else if(entry.compare(SAORI_SENDER)==0){
//			cout << "SAORI_SENDER\n";
			sender = word;
			ret = OK;
		}else if(entry.find(SAORI_ARGUMENT) == 0){
			unsigned int num;
//			cout << "SAORI_ARGUMENT\n";
			entry.erase(0,strlen(SAORI_ARGUMENT));
			num = atoi(entry.c_str());
			set_argument(word,num);
			ret = OK;
		}else{
			ret = NG;
		}
	}
	
	if(ret == NG){
		cout << "m̃wb_łB\n";
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		set_reference
//
//	<FUNCTION>	referencẽZbg
//---------------------------------------------------------------------------
int Saori_data::set_argument(string buffer,unsigned int num)
{
	int ret;
	
	if(argument.size() < (num+1)){
		argument.resize(num+1);
	}
	argument[num] = buffer;
	
	return(ret);
}


//---------------------------------------------------------------------------
//	<NAME>		header_decode
//
//	<FUNCTION>	requestf[^̃wb_fR[h
//---------------------------------------------------------------------------
int Saori_data::header_decode(string *buffer)
{
	int ret;
	int get;
	string header;
	string word;

//	cout << "Saori_data::header_decode\n";

	dic_getline(&header,buffer);
//	cout << "Saori Header:" << header << '\n';
//	cout << header.find("SHIORI/") << "\n";
	
	dic_getword(&word,&header,DIC_GET_SHIORI_HEADER);
//	cout << "Shiori Header:" << word << "\n";
	
	if(strcmp(word.c_str(),"GET") == 0){
		dic_getword(&word,&header,DIC_GET_SHIORI_HEADER);
		get = ON;
//		cout << "word:" << word << "\n";
		if(strcmp(word.c_str(),"Version") == 0){
//			cout << "GET_Version\n";
			command = string("GET Version");
			command_code = COM_GET_VERSION;
			ret = OK;
		}
	}else if(strcmp(word.c_str(),"EXECUTE") == 0){
//			cout << "EXECUTE\n";
			command = string("EXECUTE");
			command_code = COM_EXECUTE;
			ret = OK;
	}else{
		ret = NG;
	}
	
	if(get != OFF){
		dic_getword(&word,&header,DIC_GET_SHIORI_HEADER);
//		cout << word << "\n";
	}
	
	if((word.find("SAORI/") == 0) && (word.size() == 9)){
		word.erase(0,6);
		word.erase(1,1);
		command_version = atoi(word.c_str());
	}else{
		command_version = 0;
		ret = NG;
	}
	
//	cout << "END\n";
	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		encode
//
//	<FUNCTION>	requestf[^̃GR[hs
//---------------------------------------------------------------------------
int Saori_data::encode(string *answer)
{
	int ret;

	cout << "Saori_data::encode\n";
	
	ret = header_encode(answer);

	if(ret == OK){
		if(command_code != 204){
			if(command_code == COM_EXECUTE){
				if(result.size() > 0){
					answer->append("Result: ");
					answer->append(result);
					answer->append("\r\n");
				}
				if(value.size() > 0){
					char val_num[6];
					for(unsigned int count=0;count<value.size();count++){
						answer->append("Value");
						itoa(count,val_num,10);
						answer->append(val_num);
						answer->append(": ");
						answer->append(get_value(count));
						answer->append("\r\n");
					}
				}
			}
			
		}
		answer->append("Charset: Shift_JIS\r\n");
		answer->append("\r\n");
	}

//	cout << *answer << "\n";
	return(ret);
}

//---------------------------------------------------------------------------
int Saori_data::header_encode(string *answer)
{
	int ret;
	char ver_tmp[3];
	
	ret = OK;
	
	*answer = string("SAORI/");
	itoa(command_version/10,ver_tmp,10);
	answer->append(ver_tmp);
	answer->append(".");
	itoa(command_version%10,ver_tmp,10);
	answer->append(ver_tmp);
	
	switch(returncode){
		case 200:		// ɏI
			answer->append(" 200 OK\r\n");
			break;
		case 204:		// ɏIAԂׂf[^Ȃ
			answer->append(" 204 No Content\r\n");
			break;
		case 310:
			answer->append(" 310 Communicate\r\n");
			break;
		case 400:		// NGXgs
			answer->append(" 400 Bad Request\r\n");
			break;
		case 500:		// G[
			answer->append(" 500 Internal Server Error\r\n");
			break;
		default:
			ret = NG;
	}

	return(ret);
}


